import checkers.quals.*;

public class Flow {

    public void testIf(String str) {

        //String str = "foo";
        @Nonnull String a;
        if (str != null) {
           a = str;
        }

        str = null;
        @Nonnull String b = str;
    }

    public void testIfNoBlock(String str) {

        //String str = "foo";
        @Nonnull String a;
        if (str != null)
            a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testElse(String str) {

        //String str = "foo";
        @Nonnull String a;
        if (str == null) {
            testAssert("");
        } else {
            a = str;
        }

        str = null;
        @Nonnull String b = str;
    }

    public void testElseNoBlock(String str) {

        //String str = "foo";
        @Nonnull String a;
        if (str == null)
            testAssert("");
        else
            a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testReturnIf(String str) {

        //String str = "foo";
        if (str == null) {
            testAssert("");
            return;
        }

        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testReturnElse(String str) {

//        String str = "foo";
        if (str != null) {
            testAssert("");
        } else
            return;

        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testThrowIf(String str) {

        //String str = "foo";
        if (str == null) {
            testAssert("");
            throw new RuntimeException("foo");
        }

        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testThrowElse(String str) {

        //String str = "foo";
        if (str != null) {
            testAssert("");
        } else
            throw new RuntimeException("foo");

        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testAssert(String str) {

        //String str = "foo";
        assert str != null;

        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testWhile(String str) {

        //String str = "foo";
        while (str != null) {
            @Nonnull String a = str;
            break;
        }

        str = null;
        @Nonnull String b = str;
    }

    public void testIfInstanceOf(String str) {

        //String str = "foo";
        @Nonnull String a;
        if (str instanceof String) {
           a = str;
        }

        str = null;
        @Nonnull String b = str;
    }

    public void testNew() {

        String str = "foo";
        @Nonnull String a = str;

        str = null;
        @Nonnull String b = str;
    }

    public void testExit(String str) {

        //String str = null;
        if (str == null) {
            System.exit(0);
        }

        @Nonnull String a = str;
    }


    void methodThatThrowsRuntime(){
    	throw new RuntimeException();
    }

    public void retestWhile() {

    	String str = "foo";
    	while (str != null) {
    		@Nonnull String a = str;
    		break;
    	}

    	int i = 0;
    	while (true) {
    		@Nonnull String a = str;
    		str = null;
    		i++;
    		if (i > 2) break;
    	}

    	str = null;
    	@Nonnull String b = "hi";
    	try{
    		b = str;
    		methodThatThrowsRuntime();
    		str = "bar";
    	}finally{
    		b = str;
    	}

    	str = null;
    	b = str;

    	str = "hi";
    	b = (String)str;
    }
}
