package tests;

import org.junit.*;
import static org.junit.Assert.*;

import javax.tools.*;
import java.util.*;

import com.sun.source.tree.*;

/**
 * JUnit tests for the NonNull annotation checker.
 */
public class NonNullTest extends CheckerTest {

    public NonNullTest() {
        super("checkers.nonnull.NonNullChecker", "nonnull", "-Anomsgtext");
        System.setProperty("checkers.skipClasses", "");
    }

    /** Tests for expressions-sensitive analysis. */
    @Test public void testExpressions() {
        test(true);
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testFlow() {
        test(false);
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testFlowSelf() {
        test(true);
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testFlowField() {
        test(true);
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testFlowAssignment() {
        test(true);
    }

    /** Tests for flow-sensitive analysis. */
    @Test public void testMyException() {
        test(false);
    }

    /** Tests that crashes do not occur for varargs methods. */
    @Test public void testVarargs() {
        test(true);
    }

    /** Tests the @Default annotation. */
    @Test public void testDefaultAnnotation() {
        test(false);
    }

    @Test public void testArrayRefs() {
        test(false);
    }

    @Test public void testArrayArgs() {
        test(false);
    }

    @Test public void testDefaultFlow() {
        test(true);
    }

//    @Test public void testGenericArgs() {
//        test(false);
//    }

    @Test public void testMarino() {
        test(false);
    }

    // These next three shouldn't necessarily succeed (see the comments in
    // their source code), but I've inserted a test as a placeholder.

//    @Test public void testJavaCopExplosion() {
//        TestRun run = getTest("JavaCopExplosion.java");
//        assertSuccess(run);
//    }

//    @Test public void testJavaCopFlow() {
//        TestRun run = getTest("JavaCopFlow.java");
//        assertSuccess(run);
//    }

//    @Test public void testJavaCopRandomTests() {
//        TestRun run = getTest("JavaCopRandomTests.java");
//        assertSuccess(run);
//    }
}
