package tests;

import java.util.*;
import javax.tools.*;

import checkers.quals.*;

public class TestRun implements Iterable<Diagnostic<? extends JavaFileObject>> {

    private final boolean result;
    private final String output;
    private final List<Diagnostic<? extends JavaFileObject>> diagnostics;

    TestRun(/*@RoMaybe*/ Boolean result, /*@RoMaybe*/ String output,
            /*@RoMaybe*/ List<Diagnostic<? extends JavaFileObject>> diagnostics) /*@RoMaybe*/ {
       this.result = (result == true);
       this.output = output;
       this.diagnostics = Collections.unmodifiableList(diagnostics);
    }

    public boolean getResult() /*@ReadOnly*/ {
        return result;
    }

    public /*@RoMaybe*/ String getOutput() /*@RoMaybe*/ {
        return output;
    }

    public /*@RoMaybe*/ List<Diagnostic<? extends JavaFileObject>> getDiagnostics() /*@RoMaybe*/ {
        return diagnostics;
    }

    public /*@RoMaybe*/ Iterator<Diagnostic<? extends JavaFileObject>> iterator() /*@RoMaybe*/ {
        return diagnostics.iterator();
    }
}
